Index: pjproject/trunk/build.symbian/pjmediaU.def
===================================================================
--- pjproject/trunk/build.symbian/pjmediaU.def	(revision 1454)
+++ pjproject/trunk/build.symbian/pjmediaU.def	(revision 1455)
@@ -62,125 +62,126 @@
 	pjmedia_ice_init_ice                     @ 61 NONAME
 	pjmedia_ice_modify_sdp                   @ 62 NONAME
-	pjmedia_ice_start_ice                    @ 63 NONAME
-	pjmedia_ice_start_init                   @ 64 NONAME
-	pjmedia_ice_stop_ice                     @ 65 NONAME
-	pjmedia_jbuf_create                      @ 66 NONAME
-	pjmedia_jbuf_destroy                     @ 67 NONAME
-	pjmedia_jbuf_get_frame                   @ 68 NONAME
-	pjmedia_jbuf_get_state                   @ 69 NONAME
-	pjmedia_jbuf_put_frame                   @ 70 NONAME
-	pjmedia_jbuf_reset                       @ 71 NONAME
-	pjmedia_jbuf_set_adaptive                @ 72 NONAME
-	pjmedia_jbuf_set_fixed                   @ 73 NONAME
-	pjmedia_master_port_create               @ 74 NONAME
-	pjmedia_master_port_destroy              @ 75 NONAME
-	pjmedia_master_port_get_dport            @ 76 NONAME
-	pjmedia_master_port_get_uport            @ 77 NONAME
-	pjmedia_master_port_set_dport            @ 78 NONAME
-	pjmedia_master_port_set_uport            @ 79 NONAME
-	pjmedia_master_port_start                @ 80 NONAME
-	pjmedia_master_port_stop                 @ 81 NONAME
-	pjmedia_mem_capture_create               @ 82 NONAME
-	pjmedia_mem_capture_get_size             @ 83 NONAME
-	pjmedia_mem_capture_set_eof_cb           @ 84 NONAME
-	pjmedia_mem_player_create                @ 85 NONAME
-	pjmedia_mem_player_set_eof_cb            @ 86 NONAME
-	pjmedia_null_port_create                 @ 87 NONAME
-	pjmedia_plc_create                       @ 88 NONAME
-	pjmedia_plc_generate                     @ 89 NONAME
-	pjmedia_plc_save                         @ 90 NONAME
-	pjmedia_port_destroy                     @ 91 NONAME
-	pjmedia_port_get_frame                   @ 92 NONAME
-	pjmedia_port_info_init                   @ 93 NONAME
-	pjmedia_port_put_frame                   @ 94 NONAME
-	pjmedia_resample_create                  @ 95 NONAME
-	pjmedia_resample_destroy                 @ 96 NONAME
-	pjmedia_resample_get_input_size          @ 97 NONAME
-	pjmedia_resample_port_create             @ 98 NONAME
-	pjmedia_resample_run                     @ 99 NONAME
-	pjmedia_rtcp_build_rtcp                  @ 100 NONAME
-	pjmedia_rtcp_fini                        @ 101 NONAME
-	pjmedia_rtcp_get_ntp_time                @ 102 NONAME
-	pjmedia_rtcp_init                        @ 103 NONAME
-	pjmedia_rtcp_rx_rtcp                     @ 104 NONAME
-	pjmedia_rtcp_rx_rtp                      @ 105 NONAME
-	pjmedia_rtcp_tx_rtp                      @ 106 NONAME
-	pjmedia_rtp_decode_rtp                   @ 107 NONAME
-	pjmedia_rtp_encode_rtp                   @ 108 NONAME
-	pjmedia_rtp_session_init                 @ 109 NONAME
-	pjmedia_rtp_session_update               @ 110 NONAME
-	pjmedia_session_check_dtmf               @ 111 NONAME
-	pjmedia_session_create                   @ 112 NONAME
-	pjmedia_session_destroy                  @ 113 NONAME
-	pjmedia_session_dial_dtmf                @ 114 NONAME
-	pjmedia_session_enum_streams             @ 115 NONAME
-	pjmedia_session_get_dtmf                 @ 116 NONAME
-	pjmedia_session_get_info                 @ 117 NONAME
-	pjmedia_session_get_port                 @ 118 NONAME
-	pjmedia_session_get_stream_stat          @ 119 NONAME
-	pjmedia_session_info_from_sdp            @ 120 NONAME
-	pjmedia_session_pause                    @ 121 NONAME
-	pjmedia_session_pause_stream             @ 122 NONAME
-	pjmedia_session_resume                   @ 123 NONAME
-	pjmedia_session_resume_stream            @ 124 NONAME
-	pjmedia_session_set_dtmf_callback        @ 125 NONAME
-	pjmedia_silence_det_apply                @ 126 NONAME
-	pjmedia_silence_det_create               @ 127 NONAME
-	pjmedia_silence_det_detect               @ 128 NONAME
-	pjmedia_silence_det_disable              @ 129 NONAME
-	pjmedia_silence_det_set_adaptive         @ 130 NONAME
-	pjmedia_silence_det_set_fixed            @ 131 NONAME
-	pjmedia_silence_det_set_name             @ 132 NONAME
-	pjmedia_silence_det_set_params           @ 133 NONAME
-	pjmedia_snd_port_connect                 @ 134 NONAME
-	pjmedia_snd_port_create                  @ 135 NONAME
-	pjmedia_snd_port_create_player           @ 136 NONAME
-	pjmedia_snd_port_create_rec              @ 137 NONAME
-	pjmedia_snd_port_destroy                 @ 138 NONAME
-	pjmedia_snd_port_disconnect              @ 139 NONAME
-	pjmedia_snd_port_get_ec_tail             @ 140 NONAME
-	pjmedia_snd_port_get_port                @ 141 NONAME
-	pjmedia_snd_port_get_snd_stream          @ 142 NONAME
-	pjmedia_snd_port_set_ec                  @ 143 NONAME
-	pjmedia_splitcomb_create                 @ 144 NONAME
-	pjmedia_splitcomb_create_rev_channel     @ 145 NONAME
-	pjmedia_splitcomb_set_channel            @ 146 NONAME
-	pjmedia_stream_check_dtmf                @ 147 NONAME
-	pjmedia_stream_create                    @ 148 NONAME
-	pjmedia_stream_destroy                   @ 149 NONAME
-	pjmedia_stream_dial_dtmf                 @ 150 NONAME
-	pjmedia_stream_get_dtmf                  @ 151 NONAME
-	pjmedia_stream_get_port                  @ 152 NONAME
-	pjmedia_stream_get_stat                  @ 153 NONAME
-	pjmedia_stream_get_transport             @ 154 NONAME
-	pjmedia_stream_info_from_sdp             @ 155 NONAME
-	pjmedia_stream_pause                     @ 156 NONAME
-	pjmedia_stream_resume                    @ 157 NONAME
-	pjmedia_stream_set_dtmf_callback         @ 158 NONAME
-	pjmedia_stream_start                     @ 159 NONAME
-	pjmedia_strerror                         @ 160 NONAME
-	pjmedia_tonegen_create                   @ 161 NONAME
-	pjmedia_tonegen_create2                  @ 162 NONAME
-	pjmedia_tonegen_get_digit_map            @ 163 NONAME
-	pjmedia_tonegen_is_busy                  @ 164 NONAME
-	pjmedia_tonegen_play                     @ 165 NONAME
-	pjmedia_tonegen_play_digits              @ 166 NONAME
-	pjmedia_tonegen_set_digit_map            @ 167 NONAME
-	pjmedia_tonegen_stop                     @ 168 NONAME
-	pjmedia_transport_udp_attach             @ 169 NONAME
-	pjmedia_transport_udp_close              @ 170 NONAME
-	pjmedia_transport_udp_create             @ 171 NONAME
-	pjmedia_transport_udp_create2            @ 172 NONAME
-	pjmedia_transport_udp_get_info           @ 173 NONAME
-	pjmedia_transport_udp_simulate_lost      @ 174 NONAME
-	pjmedia_wav_player_port_create           @ 175 NONAME
-	pjmedia_wav_player_port_get_pos          @ 176 NONAME
-	pjmedia_wav_player_port_set_pos          @ 177 NONAME
-	pjmedia_wav_player_set_eof_cb            @ 178 NONAME
-	pjmedia_wav_playlist_create              @ 179 NONAME
-	pjmedia_wav_playlist_set_eof_cb          @ 180 NONAME
-	pjmedia_wav_writer_port_create           @ 181 NONAME
-	pjmedia_wav_writer_port_get_pos          @ 182 NONAME
-	pjmedia_wav_writer_port_set_cb           @ 183 NONAME
-	pjmedia_wave_hdr_file_to_host            @ 184 NONAME
-	pjmedia_wave_hdr_host_to_file            @ 185 NONAME
+	pjmedia_ice_simulate_lost                @ 63 NONAME
+	pjmedia_ice_start_ice                    @ 64 NONAME
+	pjmedia_ice_start_init                   @ 65 NONAME
+	pjmedia_ice_stop_ice                     @ 66 NONAME
+	pjmedia_jbuf_create                      @ 67 NONAME
+	pjmedia_jbuf_destroy                     @ 68 NONAME
+	pjmedia_jbuf_get_frame                   @ 69 NONAME
+	pjmedia_jbuf_get_state                   @ 70 NONAME
+	pjmedia_jbuf_put_frame                   @ 71 NONAME
+	pjmedia_jbuf_reset                       @ 72 NONAME
+	pjmedia_jbuf_set_adaptive                @ 73 NONAME
+	pjmedia_jbuf_set_fixed                   @ 74 NONAME
+	pjmedia_master_port_create               @ 75 NONAME
+	pjmedia_master_port_destroy              @ 76 NONAME
+	pjmedia_master_port_get_dport            @ 77 NONAME
+	pjmedia_master_port_get_uport            @ 78 NONAME
+	pjmedia_master_port_set_dport            @ 79 NONAME
+	pjmedia_master_port_set_uport            @ 80 NONAME
+	pjmedia_master_port_start                @ 81 NONAME
+	pjmedia_master_port_stop                 @ 82 NONAME
+	pjmedia_mem_capture_create               @ 83 NONAME
+	pjmedia_mem_capture_get_size             @ 84 NONAME
+	pjmedia_mem_capture_set_eof_cb           @ 85 NONAME
+	pjmedia_mem_player_create                @ 86 NONAME
+	pjmedia_mem_player_set_eof_cb            @ 87 NONAME
+	pjmedia_null_port_create                 @ 88 NONAME
+	pjmedia_plc_create                       @ 89 NONAME
+	pjmedia_plc_generate                     @ 90 NONAME
+	pjmedia_plc_save                         @ 91 NONAME
+	pjmedia_port_destroy                     @ 92 NONAME
+	pjmedia_port_get_frame                   @ 93 NONAME
+	pjmedia_port_info_init                   @ 94 NONAME
+	pjmedia_port_put_frame                   @ 95 NONAME
+	pjmedia_resample_create                  @ 96 NONAME
+	pjmedia_resample_destroy                 @ 97 NONAME
+	pjmedia_resample_get_input_size          @ 98 NONAME
+	pjmedia_resample_port_create             @ 99 NONAME
+	pjmedia_resample_run                     @ 100 NONAME
+	pjmedia_rtcp_build_rtcp                  @ 101 NONAME
+	pjmedia_rtcp_fini                        @ 102 NONAME
+	pjmedia_rtcp_get_ntp_time                @ 103 NONAME
+	pjmedia_rtcp_init                        @ 104 NONAME
+	pjmedia_rtcp_rx_rtcp                     @ 105 NONAME
+	pjmedia_rtcp_rx_rtp                      @ 106 NONAME
+	pjmedia_rtcp_tx_rtp                      @ 107 NONAME
+	pjmedia_rtp_decode_rtp                   @ 108 NONAME
+	pjmedia_rtp_encode_rtp                   @ 109 NONAME
+	pjmedia_rtp_session_init                 @ 110 NONAME
+	pjmedia_rtp_session_update               @ 111 NONAME
+	pjmedia_session_check_dtmf               @ 112 NONAME
+	pjmedia_session_create                   @ 113 NONAME
+	pjmedia_session_destroy                  @ 114 NONAME
+	pjmedia_session_dial_dtmf                @ 115 NONAME
+	pjmedia_session_enum_streams             @ 116 NONAME
+	pjmedia_session_get_dtmf                 @ 117 NONAME
+	pjmedia_session_get_info                 @ 118 NONAME
+	pjmedia_session_get_port                 @ 119 NONAME
+	pjmedia_session_get_stream_stat          @ 120 NONAME
+	pjmedia_session_info_from_sdp            @ 121 NONAME
+	pjmedia_session_pause                    @ 122 NONAME
+	pjmedia_session_pause_stream             @ 123 NONAME
+	pjmedia_session_resume                   @ 124 NONAME
+	pjmedia_session_resume_stream            @ 125 NONAME
+	pjmedia_session_set_dtmf_callback        @ 126 NONAME
+	pjmedia_silence_det_apply                @ 127 NONAME
+	pjmedia_silence_det_create               @ 128 NONAME
+	pjmedia_silence_det_detect               @ 129 NONAME
+	pjmedia_silence_det_disable              @ 130 NONAME
+	pjmedia_silence_det_set_adaptive         @ 131 NONAME
+	pjmedia_silence_det_set_fixed            @ 132 NONAME
+	pjmedia_silence_det_set_name             @ 133 NONAME
+	pjmedia_silence_det_set_params           @ 134 NONAME
+	pjmedia_snd_port_connect                 @ 135 NONAME
+	pjmedia_snd_port_create                  @ 136 NONAME
+	pjmedia_snd_port_create_player           @ 137 NONAME
+	pjmedia_snd_port_create_rec              @ 138 NONAME
+	pjmedia_snd_port_destroy                 @ 139 NONAME
+	pjmedia_snd_port_disconnect              @ 140 NONAME
+	pjmedia_snd_port_get_ec_tail             @ 141 NONAME
+	pjmedia_snd_port_get_port                @ 142 NONAME
+	pjmedia_snd_port_get_snd_stream          @ 143 NONAME
+	pjmedia_snd_port_set_ec                  @ 144 NONAME
+	pjmedia_splitcomb_create                 @ 145 NONAME
+	pjmedia_splitcomb_create_rev_channel     @ 146 NONAME
+	pjmedia_splitcomb_set_channel            @ 147 NONAME
+	pjmedia_stream_check_dtmf                @ 148 NONAME
+	pjmedia_stream_create                    @ 149 NONAME
+	pjmedia_stream_destroy                   @ 150 NONAME
+	pjmedia_stream_dial_dtmf                 @ 151 NONAME
+	pjmedia_stream_get_dtmf                  @ 152 NONAME
+	pjmedia_stream_get_port                  @ 153 NONAME
+	pjmedia_stream_get_stat                  @ 154 NONAME
+	pjmedia_stream_get_transport             @ 155 NONAME
+	pjmedia_stream_info_from_sdp             @ 156 NONAME
+	pjmedia_stream_pause                     @ 157 NONAME
+	pjmedia_stream_resume                    @ 158 NONAME
+	pjmedia_stream_set_dtmf_callback         @ 159 NONAME
+	pjmedia_stream_start                     @ 160 NONAME
+	pjmedia_strerror                         @ 161 NONAME
+	pjmedia_tonegen_create                   @ 162 NONAME
+	pjmedia_tonegen_create2                  @ 163 NONAME
+	pjmedia_tonegen_get_digit_map            @ 164 NONAME
+	pjmedia_tonegen_is_busy                  @ 165 NONAME
+	pjmedia_tonegen_play                     @ 166 NONAME
+	pjmedia_tonegen_play_digits              @ 167 NONAME
+	pjmedia_tonegen_set_digit_map            @ 168 NONAME
+	pjmedia_tonegen_stop                     @ 169 NONAME
+	pjmedia_transport_udp_attach             @ 170 NONAME
+	pjmedia_transport_udp_close              @ 171 NONAME
+	pjmedia_transport_udp_create             @ 172 NONAME
+	pjmedia_transport_udp_create2            @ 173 NONAME
+	pjmedia_transport_udp_get_info           @ 174 NONAME
+	pjmedia_transport_udp_simulate_lost      @ 175 NONAME
+	pjmedia_wav_player_port_create           @ 176 NONAME
+	pjmedia_wav_player_port_get_pos          @ 177 NONAME
+	pjmedia_wav_player_port_set_pos          @ 178 NONAME
+	pjmedia_wav_player_set_eof_cb            @ 179 NONAME
+	pjmedia_wav_playlist_create              @ 180 NONAME
+	pjmedia_wav_playlist_set_eof_cb          @ 181 NONAME
+	pjmedia_wav_writer_port_create           @ 182 NONAME
+	pjmedia_wav_writer_port_get_pos          @ 183 NONAME
+	pjmedia_wav_writer_port_set_cb           @ 184 NONAME
+	pjmedia_wave_hdr_file_to_host            @ 185 NONAME
+	pjmedia_wave_hdr_host_to_file            @ 186 NONAME
Index: pjproject/trunk/build.symbian/pjnathU.def
===================================================================
--- pjproject/trunk/build.symbian/pjnathU.def	(revision 1454)
+++ pjproject/trunk/build.symbian/pjnathU.def	(revision 1455)
@@ -77,9 +77,10 @@
 	pj_stun_session_set_server_name          @ 76 NONAME
 	pj_stun_session_set_user_data            @ 77 NONAME
-	pj_stun_sockaddr_attr_create             @ 78 NONAME
-	pj_stun_string_attr_create               @ 79 NONAME
-	pj_stun_uint64_attr_create               @ 80 NONAME
-	pj_stun_uint_attr_create                 @ 81 NONAME
-	pj_stun_unknown_attr_create              @ 82 NONAME
-	pjnath_init                              @ 83 NONAME
-	pjnath_perror                            @ 84 NONAME
+	pj_stun_set_padding_char                 @ 78 NONAME
+	pj_stun_sockaddr_attr_create             @ 79 NONAME
+	pj_stun_string_attr_create               @ 80 NONAME
+	pj_stun_uint64_attr_create               @ 81 NONAME
+	pj_stun_uint_attr_create                 @ 82 NONAME
+	pj_stun_unknown_attr_create              @ 83 NONAME
+	pjnath_init                              @ 84 NONAME
+	pjnath_perror                            @ 85 NONAME